\section{JNukeBCPatch}

\texttt{JNukeBCPatch} is an object capable of patching single Java
bytecode instructions. It can also perform some advanced bytecode
transformations, such as expanding a specific narrow bytecode instruction
into its wide instruction format while semantically retaining its arguments.
The instructions how bytecodes should be modified are taken from a 
\texttt{JNukeBCPatchMap} object that is registered with the object 
prior modifications are made.

\subsection{Constructor}

\code{
JNukeObj * \\
JNukeBCPatch\_new ( \\
\tab	JNukeMem * mem \\
)
}

\subsubsection{Description}

Create a new instance of a \texttt{JNukeBCPatch} object. The
memory required for the object instance is drawn from the
memory manager \texttt{mem}.

\subsubsection{Parameters}

\begin{description}
\ttitem{mem}
	Memory manager object
\end{description}

\subsubsection{Return value}

A reference to a newly created object of type \texttt{JNukeBCPatch}

%% -----------------------------------------------------

\subsection{JNukeBCPatch\_getPatchMap}

\code{
JNukeObj * \\
JNukeBCPatch\_getPatchMap( \\
\tab	const JNukeObj * this \\
)
}

\subsubsection{Description}

Get patch map associated with this object. The current
patch map object may be set using the function \\
\texttt{JNukeBCPatch\_setPatchMap}.

\subsubsection{Parameters}

\begin{description}
\ttitem{this}
	Reference to a patch object
\end{description}

%% -----------------------------------------------------

\subsection{JNukeBCPatch\_setPatchMap}

\code{
void \\
JNukeBCPatch\_setPatchMap ( \\
\tab	JNukeObj * this, \\
\tab	const JNukeObj * map  \\
)
}

\subsubsection{Description}

Set patch map associated with this patch object. The patch map contains
the rules how instructions should be modified during the patch process.
The current patch map may be queried using the 
\texttt{JNukeBCPatch\_getPatchMap} function.

\subsubsection{Parameters}

\begin{description}
\ttitem{this}
	Reference to a patch object
\ttitem{map}
	A reference to the object that should be the new 
	setting for the patch map property.
\end{description}


%% -----------------------------------------------------

\subsection{JNukeBCPatch\_patchByteCode}

\code{
int \\
JNukeBCPatch\_patchBytCode ( \\
\tab	JNukeObj * this, \\
\tab	JNukeObj * bc, \\
\tab	JNukeObj * instrument \\
)
}

\subsubsection{Description}

Patch a bytecode object according to the patch map associated with
this object. This method is capable of gracefully handling overflows in 
relative offsets of branch instructions, either by expanding narrow
branch instructions to their wide format counterpart or by implementing
a substitute by completely rewriting the bytecode. As a side effect,
instructions may be therefore added or removed from the current method 
given by the instrumentation context.

\subsubsection{Parameters}

\begin{description}
\ttitem{this}
	Reference to the patch object
\ttitem{bc}
	Bytecode instruction object to be patched
\ttitem{instrument}
	In case of difficulties, the instrumentation context provided by
	this instrument is used to implement substitutes for overflows in
	relative offsets.
\end{description}

\subsubsection{Return value}

This method returns true if a substitute for offset overflow had to
be inserted.

%% -----------------------------------------------------

\subsection{JNukeBCPatch\_turnIf}

\code{
int \\
JNukeBCPatch\_turnIf (  \\
\tab	const int op \\
)
}

\subsubsection{Description}

Given a branch-related Java bytecode opcode that uses a relative
offset, return its counterpart that does exactly the opposite.
For example return the opcode \texttt{ifnonnull} for \texttt{ifnull}.

\begin{description}
\ttitem{opcode}
	Bytecode instruction opcode to be transformed
\end{description}

\subsubsection{Return value}

Opcode doing the opposite. If the instruction has no opposite command,
the original opcode is returned.

